-----------------------------------------------------------------------
-- Locale
-----------------------------------------------------------------------
local L = AceLibrary("AceLocale-2.2"):new("Violation: Threat")

L:RegisterTranslations("enUS", function() return {
	["Global Threat"] = true,
	["T"] = true,
} end)

-----------------------------------------------------------------------
-- Locals
-----------------------------------------------------------------------

local playerName = nil
local data = nil
local broadcastdirty = 0
local dirty = nil
local moduleName = "Threat"

local roster = AceLibrary("Roster-2.1")

-----------------------------------------------------------------------
-- Module declaration
-----------------------------------------------------------------------

local mod = Violation:NewModule(moduleName)
mod.revision = tonumber(("$Revision: 37766 $"):sub(12, -3)) or 1
mod.version = 4
mod.canMergeData = false

-----------------------------------------------------------------------
-- Module initialization
-----------------------------------------------------------------------

function mod:OnModuleRegister()
	playerName = UnitName("player")
	data = self:new()
end

function mod:OnModuleEnable()
	self:RegisterEvent("Threat_ThreatUpdated")
end

function mod:OnModuleDisable()
	self:UnregisterAllEvents()
end

function mod:OnReset()
	if type(data) == "table" then
		data = self:del(data)
	end

	data = self:new()
	data[playerName] = 0
	dirty = nil
	broadcastdirty = 0
end

-----------------------------------------------------------------------
-- Module implementation
-----------------------------------------------------------------------

function mod:GetRevision() return self.revision end
function mod:GetDisplayName() return L["Global Threat"] end
function mod:GetShortDisplayName() return L["T"] end
function mod:GetBroadcastData()
	return
end

function mod:IsBroadcastDirty()
	return false
end

function mod:IsDirty()
	return dirty
end

function mod:ResetDirty()
	dirty = nil
end

function mod:OnRemoteData(sender, input)
	return
end

function mod:Threat_ThreatUpdated( name, unit, target, value )
	local unitid = roster:GetUnitIDFromName( name )
	if not unitid or target ~= '_GLOBAL_' then
		return
	end
	
	data[name] = value
	dirty = true
	
end

function mod:GetData(player)
	if player then
		return data[player]
	else
		return data
	end
end


